{
This test application simply lets you enter an NTP value and it will spit the date
and time out in a terminal program.

Here is a link to a good calculator to get NTP and UTC values from: http://www.aelius.com/njh/unixtime/


To incorporate SNTP 1.3 into your application:

     1) Insert GMT, Zone and DLS into your calling application CON block.
          *Modify DLS and GMT as appropriate for daylight savings and your time zone.

     2) Include SNTP 1.3 as an object in your calling application.
          *call it whatever you want.
          
     3) Make sure you include the variables in the VAR section below in your calling application.
          *users of Mike G's httpserv probably already have these in the VAR section. That's fine.

     4) Replace your get_sntp_time method in your calling application with the one in this object.
          *Just cut and paste it, replacing the one you're already using.

     5) OPTIONAL-  Replace your get_sntp method with the one included in this object.
          *It works with up to three  time servers for a little better reliability.
          *if you use this method, include the DAT section below in your calling application.
          *These are 3 operational sntp servers.
          *There's a whole slew of them here: http://tf.nist.gov/tf-cgi/servers.cgi

SNTP 1.3 has been tested thoroughly. There are no known bugs and it has been tested with over 5000
random ntp timestamp values and checked against a known calculator.

P.S.  If you use this version and decide to extend the daylight savings time values in the DST method
      PLEASE send me the values so I can extend mind too. It's a pain to look up the values
      and I really don't want to if someone else will do it for me!  ;^)
}
CON
     _clkmode = xtal1 + pll16x     
     _xinfreq = 5_000_000

     GMT=0                  'GreenwichMeanTime

     Zone = GMT-5           'Eastern Standard Time =  GMT-5
     DLS  = 1               'DaylightSavings: 1 = use daylight savings. 0 = do NOT use daylight savings.

OBJ
     pst:    "parallax serial terminal"
     sntp:   "sntp 1.3"
     
VAR

     long longHIGH,longLOW,MM_DD_YYYY,DW_HH_MM_SS 'can't change these.  Needs 4-contigous variables

DAT

  'Do NOT move these. They MUST remain as is.
  sntpIp                byte    111, 111, 111, 111{Dummy value: Will be automatically replaced by one below.}  
  sntpIp1               byte    64,  250, 177, 145   {U. of Co.  Co. =          128, 138, 141, 172 }        
  sntpIp2               byte    64,  236, 96,  53    {Reston Va =               64,  236, 96,  53  }
  sntpIp3               byte    64,  250, 177, 145   {Atlanta Ga =              64,  250, 177, 145 }
  
pub start | temp , temp2 ,temp3 ,temp4

     pst.Start(115_200)

     pst.Str(String("Starting..."))
     Waiting(3000)

     repeat

          main
     
pub main | temp , temp2

    '3_534_364_800 is the ntp value for 2012, Jan 01, 0:00:00 hours.  If you enter this value, you'll get an error
    'because of the daylight savings adjustments and time zone adjustments.
    'for practical testing, enter an NTP value for a date and time of Jan 02, 2012 or later (3534451200)
    '2038, jan 19, 03:14:07 is the latest date and time supported by NTP and SNTP (4356472447)

    pst.clear
    pst.Str(String("Enter a valid NTP value:"))
    longHIGH := pst.Decin
    pst.newline

    Temp2 := byte[longHIGH][0]<<24+byte[longHIGH][1]<<16
    Temp2 += byte[longHIGH][2]<<8 +byte[longHIGH][3]

    long[longHIGH]:=Temp2     

    sntp.HumanTime(zone,DLS,@longHIGH)

    pst.Str(String("Resulting date and time:"))
    pst.newline

    pst.Str(String("Year: "))
    pst.Dec(word[@MM_DD_YYYY][0])
    pst.NewLine

    pst.Str(String("Month: "))
    pst.Dec(byte[@MM_DD_YYYY][3])
    pst.NewLine

    pst.Str(String("Day: "))
    pst.Dec(byte[@MM_DD_YYYY][2])
    pst.NewLine

    pst.Str(String("D of W: "))
    pst.Dec(byte[@DW_HH_MM_SS][3])
    pst.NewLine
    
    pst.Str(String("Hours: "))
    pst.Dec(byte[@DW_HH_MM_SS][2])
    pst.NewLine

    pst.Str(String("Minutes: "))
    pst.Dec(byte[@DW_HH_MM_SS][1])
    pst.NewLine

    pst.Str(String("Seconds: "))
    pst.Dec(byte[@DW_HH_MM_SS][0])
    pst.NewLine

    pst.Str(String("(Press enter to calculate a new value)"))

    temp := pst.charin
{
Pri get_sntp(id)| i , size

  repeat i from 4 to 15 step 4   'Tries up to 3 different ntp servers for RTC updating.

     bytemove(@sntpIp,@sntpIp+i,4) 

     Socket.Close(id)
     waiting(delay)
   
     Socket.Initialize(id, UDP_PROTOCOL, uport, sntpPort, @sntpIp)
     waiting(delay)
 
     pst.str(string("SNTP Connect: " ))
     pst.Newline
     empty_buffer(@rxdata)
     empty_buffer(@txdata)  
     size := get_sntp_time(id,@rxdata)
     If size => 56
        pst.str(string("Success."))
        pst.NewLine
        sntp.GetTransmitTimestamp(Zone,DLS,@rxdata,@LongHIGH,@LongLOW)
        rtc.writeTime(byte[@DW_HH_MM_SS][0],byte[@DW_HH_MM_SS][1],byte[@DW_HH_MM_SS][2],byte[@DW_HH_MM_SS][3],byte[@MM_DD_YYYY][2],byte[@MM_DD_YYYY][3],word[@MM_DD_YYYY][0])
                         'second,               minute,               hour,                 day of week,          day,                month,               year
        quit

     Else
        pst.str(string("Failed."))
        pst.NewLine        
        waiting(100)


PUB get_sntp_time(id, BufferAddress)|i
                
    sntp.CreateUDPtimeheader(BufferAddress,@sntpIp)   'Fill the buffer with the udp packet junk to send.
    Socket.txUDP(id, BufferAddress)                   'Send the UDP packet
    
    repeat 100                                        'repeat 100 times.
      i := Socket.rxUDP(id, BufferAddress)            'i = the # of bytes we get in the response.
      if i=>56                                        'if we have at least 56 bytes, we have a full packet response.
         return i                  
      waiting(100) '<- if 1000 = 1 sec ; 10 = 1/100th sec X 100 repeats above = 1 sec   

    return 0     '<- Timed out without a response
}
pub Waiting(Time) | AutoTime, Cycle                    

  Cycle:=cnt                      
  AutoTime:=clkfreq/1000 * Time   
  waitcnt(Cycle+=AutoTime)        